#pragma once

#include "ActorInterface.h"
#include "WASActor.h"
#include "WASCommand.h"
#include "WASActor.h"

class CWASSearchBuddy : public CWASCommand
{
public:
	CWASSearchBuddy(CWASActor *pActor);
	~CWASSearchBuddy(void);

	void ExecuteAsync(void);

	void SetParameter(LPCWSTR strBuddyID)
	{
		m_bSuccess = false;

		m_sResult.Clear();

		m_sResult.strUserID = strBuddyID;
	}

private:
	bool ParseAndEventFire(nfc::CIkXMLDom * pDom);

protected:
	// override in drived class
	virtual void OnWasResponse(trid_t /*trid*/, bool /*bSuccess*/, int /*nWinINetErrorCode*/, int /*nHttpResponseCode*/, 
		LPCSTR /*szWasResCodeInHeader*/, 
		LPCSTR /*szWasResCodeInXml*/,
		nfc::CIkXMLDom * /*pDom*/);

	virtual void OnRequestTimeout(CHttpFacade * /*pHttpF*/, DWORD /*dwSeconds*/);

private:

	P_GT_BUDDY_SEARCH_RESULT_DATA m_sResult;
	bool m_bSuccess;
};
